
#include "usart1.h"
#include "debug.h"

void USART1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/********************************************************************************************************
** : USART1_Init,  1ʼ
********************************************************************************************************/
void USART1_Init(uint32_t bound)
{
    GPIO_InitTypeDef  GPIO_InitStructure={0};
    USART_InitTypeDef USART_InitStructure={0};
    NVIC_InitTypeDef  NVIC_InitStructure={0};

    /* GPIOUSARTʱ */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

    /* GPIOģʽIO */
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_9;            // PA9(TX)
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;    // IOƵ
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP;      // 
    GPIO_Init(GPIOA,&GPIO_InitStructure);              // ʼ
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_10;           // PA10(RX)
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;        // 
    GPIO_Init(GPIOA,&GPIO_InitStructure);              // ʼ

    /* ôӲ */
    USART_InitStructure.USART_BaudRate = bound;    /*  */
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No ;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
    USART_Init(USART1, &USART_InitStructure);

    /* ʹܴ1ж */
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);    /* ʹܴڿж */
    USART_Cmd(USART1, ENABLE);        /* ʹܴ */
}

void USARTx_SendByte(USART_TypeDef* pUSARTx, uint8_t data)
{
    USART_SendData(pUSARTx, data);
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);
}

void USARTx_SendStr(USART_TypeDef* pUSARTx, char *str)
{
    uint8_t i = 0;
    do
    {
       USARTx_SendByte(pUSARTx, *(str+i));
       i++;
    }while(*(str+i) != '\0');
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TC) == RESET);
}

/********************************************************************************************************
** : USART1_IRQHandler,  1жϷ
********************************************************************************************************/
void USART1_IRQHandler(void)
{
    uint8_t ucTemp;
    if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET) //жϲ
    {
         USART_ClearITPendingBit(USART1,USART_IT_RXNE);    //жϱ־
         ucTemp = USART_ReceiveData(USART1);               //
         USART_SendData(USART1, ucTemp);                   //
    }
}
